import { renderless, api } from '@opentinyvue/vue-renderless/button/vue';
import { defineComponent, props, setup } from '@opentinyvue/vue-common';
import { iconLoadingShadow } from '@opentinyvue/vue-icon';
import '@opentinyvue/vue-theme/button/index.css';

function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  var hook;
  if (injectStyles) {
    hook = injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

var __vue2_script = defineComponent({
  emits: ["click"],
  props: [].concat(props, ["type", "text", "size", "icon", "resetTime", "nativeType", "loading", "disabled", "plain", "autofocus", "round", "circle", "tabindex", "customClass", "ghost"]),
  components: {
    IconLoading: iconLoadingShadow()
  },
  setup: function setup$1(props2, context) {
    return setup({
      props: props2,
      context,
      renderless,
      api
    });
  }
});
var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("button", _vm._b({
    staticClass: "tiny-button",
    class: [_vm.type ? "tiny-button--" + _vm.type : "", _vm.size ? "tiny-button--" + _vm.size : "", {
      "is-disabled": _vm.state.buttonDisabled,
      "is-loading": _vm.loading,
      "is-plain": _vm.state.plain,
      "is-ghost": _vm.ghost,
      "is-round": _vm.state.round,
      "is-circle": _vm.circle,
      "is-icon": _vm.icon && !_vm.loading && (_vm.text || _vm.slots.default),
      "is-only-icon": _vm.icon && !_vm.loading && !(_vm.text || _vm.slots.default)
    }],
    attrs: {
      "disabled": _vm.state.buttonDisabled || _vm.loading,
      "autofocus": _vm.autofocus,
      "type": _vm.nativeType,
      "tabindex": _vm.tabindex
    },
    on: {
      "click": _vm.handleClick
    }
  }, "button", _vm.a(_vm.$attrs, ["class", "style", "title", "id"], true), false), [_vm.loading ? _c("icon-loading", {
    staticClass: "tiny-icon-loading tiny-svg-size"
  }) : _vm._e(), _vm.icon && !_vm.loading ? _c(_vm.icon, {
    tag: "component",
    class: {
      "is-text": _vm.text || _vm.slots.default
    }
  }) : _vm._e(), _vm._t("default", function() {
    return [_c("span", [_vm._v(_vm._s(_vm.text))])];
  })], 2);
};
var staticRenderFns = [];
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var pc = /* @__PURE__ */ function() {
  return __component__.exports;
}();

export { pc as default };
